import { ApiCall } from "tsrpc";
import { ReqGiftRec, ResGiftRec } from "../../../shared/protocols/event/huangqijiuguan/PtlGiftRec";
import HQJGFun from "./fun";

export default async function (call: ApiCall<ReqGiftRec, ResGiftRec>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);
    if (!hd || Object.keys(hd).length <= 0) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let gift = hd.data.gift.filter(i => i.id == call.req.giftid)[0];
    if (!gift || !gift.free) {
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let mydata = await HQJGFun.getMydata(call, call.req.hdid);
    if ((mydata.giftbuy[call.req.giftid] || { num: 0 }).num + 1 > gift.buynum) {
        return call.error("", { code: -2, message: globalThis.lng.hqjgtips_28 })
    }

    let prize: atn[] = [].concat(gift.prize);
    if (!mydata.giftbuy[call.req.giftid]) {
        mydata.giftbuy[call.req.giftid] = { num: 0, select: [] };
    }

    if (gift.dlz) {
        for (let i = 0; i < gift.dlz.length; i++) {
            if (!mydata.giftbuy[call.req.giftid].select[i]) {
                let ids = Object.keys(gift.dlz[i])
                prize.push(gift.dlz[i][ids[0]]);
                mydata.giftbuy[call.req.giftid].select[i] = Number(ids[0]);
            } else {
                prize.push(gift.dlz[i][mydata.giftbuy.select[i]]);
            }
        }
    }
    mydata.giftbuy[call.req.giftid].num++;
    await HQJGFun.setMyData(call.uid, call.req.hdid, { giftbuy: mydata.giftbuy });

    call.succ({ data: mydata, prize: prize })
}
