import { ApiCall } from "tsrpc";
import { ReqGiftSelect, ResGiftSelect } from "../../../shared/protocols/event/huangqijiuguan/PtlGiftSelect";
import HQJGFun from "./fun";

export default async function (call: ApiCall<ReqGiftSelect, ResGiftSelect>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);
    if (!hd || Object.keys(hd).length <= 0) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let gift = hd.data.gift[call.req.giftid];
    if (!gift || !gift.dlz) {
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    for (let i = 0; i < call.req.seletc.length; i++) {
        if (!gift.dlz[i] || !gift.dlz[i][call.req.seletc[i]]) {
            return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
        }
    }

    let mydata = await HQJGFun.getMydata(call, call.req.hdid);
    if (!mydata.giftbuy[call.req.giftid]) {
        mydata.giftbuy[call.req.giftid] = {
            num: 0, select: call.req.seletc
        }
    } else {
        mydata.giftbuy[call.req.giftid].select = call.req.seletc;
    }

    await HQJGFun.setMyData(call.uid, call.req.hdid, { giftbuy: mydata.giftbuy });

    call.succ({ data: mydata });
}